# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
from tools.translate import _
from crm import crm
import time
import zipfile
import cStringIO
import base64

class crm_postmail_zipdocs(osv.osv_memory):
    _name = 'crm.postmail.zipdocs'
    
    _columns = {
        'name' : fields.char('Name', size=50,),
        'postmail_ids' : fields.many2many('crm.postmail', 'contact_postmail_wiz_zipdocs_rel', 'wiz_id', 'postmail_id', string='Postmails',),
        'file' : fields.binary('ZIP File', filters='*.zip', filename="name",),
        'state' : fields.selection([('draft','Draft'),('executed','Executed')], string='State',),
    }
    
    _defaults = {
        'name' : lambda *a : 'postmail_documents.zip',
        'postmail_ids' : lambda self,cr,uid,context={}: context.get('active_ids'),
        'state' : lambda *a : 'draft',
    }
    
    def create_file(self, cr, uid, ids, context=None):
        att_obj = self.pool.get('ir.attachment')
        all_postmail_ids = []
        for wiz in self.browse(cr, uid, ids, context=context):
            zipfile0 = cStringIO.StringIO()
            myzip = zipfile.ZipFile(zipfile0, 'w');c=0
            for pm in wiz.postmail_ids:
                all_postmail_ids.append(pm.id)
                att_ids = att_obj.search(cr, uid, [('res_model','=','crm.postmail'),('res_id','=',pm.id)], context=context)
                for att in att_obj.browse(cr, uid, att_ids, context=context):
                    myzip.writestr("%05d_%s" % (c, att.name), base64.decodestring(att.datas));c+=1                        
            myzip.close()
            self.write(cr, uid, [wiz.id], {'file': base64.encodestring(zipfile0.getvalue()) })
            zipfile0.close()
        self.pool.get('crm.postmail').case_close(cr, uid, all_postmail_ids)
        self.write(cr, uid, ids, {'state': 'executed',})
        return True                 
            
crm_postmail_zipdocs()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
